Hot News:

Mit Unterstützung durch:

  Foren auf CAD.de (alle Foren)
  Lisp
  Ansicht in Ansichtsfenster modifizieren

Antwort erstellen  Neues Thema erstellen
CAD.de Login | Logout | Profil | Profil bearbeiten | Registrieren | Voreinstellungen | Hilfe | Suchen

Anzeige:

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen nächster neuer Beitrag | nächster älterer Beitrag
  
Gut zu wissen: Hilfreiche Tipps und Tricks aus der Praxis prägnant, und auf den Punkt gebracht für Autodesk Produkte
Autor Thema:  Ansicht in Ansichtsfenster modifizieren (399 mal gelesen)
CADwiesel
Moderator
CAD4FM UG




Sehen Sie sich das Profil von CADwiesel an!   Senden Sie eine Private Message an CADwiesel  Schreiben Sie einen Gästebucheintrag für CADwiesel

Beiträge: 1964
Registriert: 05.09.2000

AutoCAD, Bricscad
Wir machen das Mögliche unmöglich

erstellt am: 06. Okt. 2022 08:50    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo Ihr,
ich habe ein Layout, welches ein Ansichtsfenster enthält kopiert (Neues Layout)
In dem Ansichtsfenster ist ein Objekt im Modellbereich zu sehen.
Nun kopiere ich dieses Objekt an eine andere Stelle im Modellbereich.

Jetzt kommt der Punkt....
in meinem, bereits vorher kopierten Layout mit dem Ansichtsfenster (neues Layout), möchte ich jetzt die gleiche Sicht auf das kopiere Objekt haben, wie es das 'alte' Ansichtsfenster auf das 'alte' Objekt hat.

Das Ganze soll aber nicht über commands oder Wechseln in die Layouts. oder AF's funktionieren, sondern Programmtechnisch ver Lisp/Vlisp.
In meinen händischen Versuchen ist mir aufgefallen, das der einzige Unterschied zwischen den beiden AF's der dxf 12 ist.
Ich weiß allerdings nicht, wie ich diesen Punkt zu berechnen habe, geschweige denn, was er überhaupt bedeuten soll.

Ich wäre für jegliche Hinweise zur Berechnung oder eben Neuausrichtung des AF's dankbar.

------------------
Gruß
CADwiesel
Besucht uns im CHAT

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Meldin
Mitglied



Sehen Sie sich das Profil von Meldin an!   Senden Sie eine Private Message an Meldin  Schreiben Sie einen Gästebucheintrag für Meldin

Beiträge: 381
Registriert: 15.07.2011

ACA2020
Windows10

erstellt am: 06. Okt. 2022 09:20    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für CADwiesel 10 Unities + Antwort hilfreich

Hallo,
12 zeigt dir den Fenster-Mittelpunkt den musst du auf dein neues Objekt ausrichten.
Code:
(setq CenterVP-1 (mapcar '+ VIEWP-1-GC17 VIEWP-1-GC12))
    (setq CenterVP-2 (mapcar '+ VIEWP-2-GC17 VIEWP-2-GC12))

------------------
Gruß Wolfgang 

[Diese Nachricht wurde von Meldin am 06. Okt. 2022 editiert.]

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Vino
Mitglied



Sehen Sie sich das Profil von Vino an!   Senden Sie eine Private Message an Vino  Schreiben Sie einen Gästebucheintrag für Vino

Beiträge: 205
Registriert: 24.05.2005

Windows 10
BricsCAD V20-22

erstellt am: 06. Okt. 2022 09:24    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für CADwiesel 10 Unities + Antwort hilfreich

Hallo,

soweit ich das verstehe musst du ja "nur" den Mittelpunkt der Ansicht verändern.
Das sollte (ungetestet) prinzipiell mit VLA-PUT-CENTER gehen???

Nach meiner Erfahrung ist es bei VIEWPORTS leider sehr undurchsichtig, wie die korrekten Koordinaten zu ermitteln sind.
Siehe: http://www.lee-mac.com/vpoutline.html

Gruß

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Brischke
Moderator
CAD on demand GmbH




Sehen Sie sich das Profil von Brischke an!   Senden Sie eine Private Message an Brischke  Schreiben Sie einen Gästebucheintrag für Brischke

Beiträge: 4170
Registriert: 17.05.2001

AutoCAD 20XX, defun-tools (d-tools.eu)

erstellt am: 06. Okt. 2022 14:41    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für CADwiesel 10 Unities + Antwort hilfreich

Hallo CADwiesel,

wenn du das Verschieben ebenfalls mit dem Programm erledigst, hast du ja den Basis und den Zielpunkt, sprich den Verschiebevektor (Differenz aus den beiden Punkten).
Diesen addierst du zum [Mittelpunkt der Ansicht im Modellbereich] = 12er-Gruppencode hinzu, sollte gehen.

Schwieriger wird's ggf. herauszufinden, um welches Ansichtsfenster es sich handelt, in dem das Objekt zuvor dargestellt wurde. Dazu müsstest du über die Ansichtsfenster-Daten ermitteln, welcher Bereich im Modellbereich dargestellt wurde um dann zu prüfen, ob das relevante Objekt in diesem Fenster sichtbar wäre (die Layereinstellungen des Ansichtsfenster müsste man ggf. auch noch beachten) - dafür wäre dann die Boundingbox des Objekts ein Weg.

Aber bevor ich mich hier in Eventualitäten verstricke ... werde mal konkreter, welchen Weg du gehen willst und wo es stockt.

Grüße!
Holger

------------------
Holger Brischke
CAD on demand GmbH
Individuelle Lösungen von Heute auf Morgen.


defun-tools Das Download-Portal für AutoCAD-Zusatzprogramme!


Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

CADwiesel
Moderator
CAD4FM UG




Sehen Sie sich das Profil von CADwiesel an!   Senden Sie eine Private Message an CADwiesel  Schreiben Sie einen Gästebucheintrag für CADwiesel

Beiträge: 1964
Registriert: 05.09.2000

AutoCAD, Bricscad
Wir machen das Mögliche unmöglich

erstellt am: 12. Okt. 2022 11:32    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Also eigentlich braucht man nur den Zoom center um den Verschiebevektor auf das Ansichtsfenster anzuwenden und schon passt's.
Was für Objekte in der Draufsicht und Frontansicht auch gut passt.
Wenn ich jetzt allerdings eine Seitenansicht eines Objektes habe, funktioniert es mit dem Zoom center auf einen berechneten Punkt nicht.
Ich weiß nicht warum, aber ein solcher Punkt wird nicht übernommen. Das Ansichtsfenster behält da immer den 'alten' Zentrumspunkt.

Vielleicht fällt ja dazu noch jmd. etwas ein?

Code:

(setq vec (mapcar '- p2 p1))
(setq vs (getvar 'viewsize))
(setq vc (getvar 'viewctr))
(setq nvpt (mapcar '+ vc vec))
(vlax-invoke-method (vlax-get-acad-object) 'zoomcenter (vlax-3d-point nvpt) vs)

------------------
Gruß
CADwiesel
Besucht uns im CHAT

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Dorfy
Mitglied
Double-Dipl.-Ing. Bleistiftanspitzer


Sehen Sie sich das Profil von Dorfy an!   Senden Sie eine Private Message an Dorfy  Schreiben Sie einen Gästebucheintrag für Dorfy

Beiträge: 900
Registriert: 21.07.2006

AutoCad2007, ProE, HiCad

erstellt am: 17. Okt. 2022 16:18    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für CADwiesel 10 Unities + Antwort hilfreich

Müsstest du den Vektor nicht auf das Ansichtsfenster umrechnen?
Ich hätte hier irgendwas mit "trans" erwartet.

PCS2WCS oder so ähnlich

------------------
Mfg Heiko

Elefantenjagd in Afrika
"... LISP-Programmierer bauen einen Irrgarten aus Klammern und hoffen, dass sich der Elefant darin verirrt..."
-Lots of irritating superfluous parentheses!-

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Andreas Kraus
Mitglied
Elektrotechniker


Sehen Sie sich das Profil von Andreas Kraus an!   Senden Sie eine Private Message an Andreas Kraus  Schreiben Sie einen Gästebucheintrag für Andreas Kraus

Beiträge: 1348
Registriert: 11.01.2006

WIN 10
ACAD 2022

erstellt am: 18. Okt. 2022 10:25    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für CADwiesel 10 Unities + Antwort hilfreich

Wenn ich im jeweiligen AF auf WKS stelle gehts.
Kann sein dass da ein wenig "trans" vielleicht hilft.

Allerdings ... du hast geschrieben

Zitat:
oder Wechseln in die Layouts. oder AF's funktionieren

da musst du wahrscheinlich mit eigenen Methoden die Koordinaten umrechnen.
Aber wenn du sowieso nicht in die AF wechseln willst, kannst du ja auch nicht mit getvar arbeiten, das muss ja dann alles ganz anders aussehen.
Wenn du das hast, stells mal bitte hier rein. Ich versuch auch schon lange "von Außen" zu panen und zu zoomen, bis jetzt klappts nicht.

------------------
Geht nicht, gibts nicht

Gruß
Andreas

http://kraus-cad.de

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

CADwiesel
Moderator
CAD4FM UG




Sehen Sie sich das Profil von CADwiesel an!   Senden Sie eine Private Message an CADwiesel  Schreiben Sie einen Gästebucheintrag für CADwiesel

Beiträge: 1964
Registriert: 05.09.2000

AutoCAD, Bricscad
Wir machen das Mögliche unmöglich

erstellt am: 18. Okt. 2022 11:41    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Bei den Ansichten von einer Seite links/rechts muss sicherlich ein anderer Ansichtspunkt und Vektor im Modellbereich ermittelt werden.
Das Ganze sollte aber ohne hin- und herwechseln der Bereiche funktionieren. Dauert sonst einfach zu lange.
Muss mir mal bei Gelegenheit Gedanken darüber machen.

------------------
Gruß
CADwiesel
Besucht uns im CHAT

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Dorfy
Mitglied
Double-Dipl.-Ing. Bleistiftanspitzer


Sehen Sie sich das Profil von Dorfy an!   Senden Sie eine Private Message an Dorfy  Schreiben Sie einen Gästebucheintrag für Dorfy

Beiträge: 900
Registriert: 21.07.2006

AutoCad2007, ProE, HiCad

erstellt am: 19. Okt. 2022 08:14    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für CADwiesel 10 Unities + Antwort hilfreich

Hast du dir den Code von gile aus dem link mal angesehen...
"...Without activating a viewport..."

------------------
Mfg Heiko

Elefantenjagd in Afrika
"... LISP-Programmierer bauen einen Irrgarten aus Klammern und hoffen, dass sich der Elefant darin verirrt..."
-Lots of irritating superfluous parentheses!-

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP



Praktikum Digitalisierung im Bereich Anbauwerkzeuge

Die Liebherr-Hydraulikbagger GmbH in Kirchdorf an der Iller entwickelt und fertigt ein umfangreiches Sortiment hochwertiger Hydraulikbagger, knickgelenkter Muldenkipper sowie Materialumschlagmaschinen. Die leistungsfähigen Maschinen haben ihren festen Platz in unterschiedlichsten Anwendungsbereichen vieler Industriezweige und kommen weltweit zum Einsatz.

Praktikum Digitalisierung im Bereich Anbauwerkzeuge
Job-ID 63956


Ihre Zukunft....

Anzeige ansehenMaschinenbau
CADwiesel
Moderator
CAD4FM UG




Sehen Sie sich das Profil von CADwiesel an!   Senden Sie eine Private Message an CADwiesel  Schreiben Sie einen Gästebucheintrag für CADwiesel

Beiträge: 1964
Registriert: 05.09.2000

AutoCAD, Bricscad
Wir machen das Mögliche unmöglich

erstellt am: 19. Okt. 2022 09:07    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Ein Punkt alleine sagt dir doch noch nichts über den Vektor aus, sonst wäre es ja ziemlich einfach.
Aber danke für das Dranbleiben ;-)

------------------
Gruß
CADwiesel
Besucht uns im CHAT

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Anzeige.:

Anzeige: (Infos zum Werbeplatz >>)

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen

nächster neuerer Beitrag | nächster älterer Beitrag
Antwort erstellen


Diesen Beitrag mit Lesezeichen versehen ... | Nach anderen Beiträgen suchen | CAD.de-Newsletter

Administrative Optionen: Beitrag schliessen | Archivieren/Bewegen | Beitrag melden!

Fragen und Anregungen: Kritik-Forum | Neues aus der Community: Community-Forum

(c)2022 CAD.de | Impressum | Datenschutz